#include <iostream>
#include <strstream>
#include <sstream>
#include <string>

string ConvertBase( size_t base1, size_t base2,
                    const string& src )
{
  stringstream s1( src );
  long value;

  if( !( s1 >> Num( base1, value )).eof() || 
      !( s1 >> std::ws ).eof() )
    throw logic_error( "src is not a valid number" );

  stringstream s2;
  if( !( s2 << Num( base2, value ) ) )
    throw logic_error( "unexpected error emitting "
                       "converted number" );

  return s2.str();
}

class Num
{
public:
  Num( size_t base, long& value )
  : base_(base), value_(value)
  {
    if( base < 1 || base > 36 )
      throw logic_error( "base must be from "
                         "1 to 36" );
  }

  size_t Base() const { return base_;  }
  long& Value()       { return value_; }
  long  Value() const { return value_; } 

private:
  size_t base_;
  long& value_;
};

stream& operator>>( istream& i, Num& n )
{
  string s;
  i >> s;
  n.Value() = 255; // todo: really convert input
                   //       to n's base_
  return i;
}

ostream& operator<<( ostream& o, const Num& /* n */ )
{
  return o << "FF"; // todo: really output
                    //       n.value_ in n.base_
}

int main()
{
  string result = ConvertBase( 10, 16, "255" );
  cout << result << endl;
  return result == "FF" ? 0 : 1;
}

