

// examples from Matt Austern article on streambuf and rangebuf

#include <iostream>
// #include <strstream>
// #include <sstream>
#include <string>

int main() {

  // show string output of pi to an output stream
  double pi = 3.14159265;
  std::ostringstream os;
  os << "pi = "
     << std::setprecision(3)
     << pi;
                     
  std::string line = os.str();
  assert(line == "pi = 3.14");

  // show reading integers from an input stream
  std::string s("17 42");
  std::istringstream in(s);

  int i, j;
  in >> i >> j;

  assert(i == 17);
  assert(j == 42);

  // show reading a utf16 character (unicode)
  std::basic_ostringstream<utf16> os;
  os << 42;
  std::basic_string<utf16> s = os.str();

  std::basic_ostringstream os("x = ");
  assert(os.str() == "x = ");

  os.seekp(0, std::ios::end);

  os << 42;
  assert(os.str() == "x = 42");

}
